;       CRT0 for the Amstrad CPC family
;
; 		Very bare, no malloc, no z88dk libraries
;		no firmware
;
;       Stefano Bodrato 8/6/2000
;
;       $Id: cpc_crt0.asm,v 1.15 2009/06/22 21:20:05 dom Exp $
;

        MODULE  cpc_crt0


;--------
; Include zcc_opt.def to find out some info
;--------
        INCLUDE "zcc_opt.def"

;--------
; Some scope definitions
;--------

        XREF    _main           ;main() is always external to crt0 code

     ;;   XDEF    cleanup         ;jp'd to by exit()
        XDEF    l_dcal          ;jp(hl)

      ;;  XDEF    _vfprintf       ;jp to the printf() core

      ;;  XDEF    exitsp          ;atexit() variables
      ;;  XDEF    exitcount

     ;;   XDEF    heaplast        ;Near malloc heap variables
      ;;  XDEF    heapblocks

     ;;   XDEF    __sgoioblk      ;stdio info block

     ;;   XDEF    base_graphics   ;Graphical variables
     ;;   XDEF    coords          ;Current xy position

     ;;   XDEF    snd_tick        ;Sound variable

     ;;   XDEF    call_rom3       ;Interposer

     ;;   XDEF    firmware_bc     ;Needed by the firmware interposer

;--------
; Set an origin for the application (-zorg=) default to $6000
;--------

        IF      !myzorg
                defc    myzorg  = $6000
        ENDIF   
                org     myzorg


        org     myzorg


;--------
; REAL CODE
;--------

start:
		;; run the code (no return allowed)		
        jp _main

l_dcal: jp      (hl)
