XLIB cpc_ConvertNumberToAscii
;; 
.cpc_ConvertNumberToAscii
	ld ix,2
	add ix,sp
				

	;; if we find zero do we write space
	;; or do we not increment?
	ld a,(ix+0)
	or a
	ld bc,calc_digit_0_noinc
	jr z,noinc0
	ld bc,calc_digit_0_space
.noinc0
	ld (calc_digit_jp+1),bc

	;; 16-bit number to display
	ld l,(ix+2)
	ld h,(ix+3)

	;; if zero do not show + or -
	ld a,h
	or l
	ld a,' '
	jr z,its_zero
	;; if +ve will show +
	ld a,'+'
.its_zero		
	;; buffer to write string to
	ld e,(ix+4)
	ld d,(ix+5)
	push de
		
	;; negative?
	bit 7,h
	jr z,negative_num
	
	;; negate number
	ld a,l
	cpl
	ld l,a
	ld a,h
	cpl
	ld h,a
	inc hl
	
	ld a,'-'
.negative_num
	ld (de),a
	inc de
	
	
	ld bc,100
	call calc_digit
	ld bc,10
	call calc_digit
	ld a,l
	call calc_digit_norm
	xor a
	ld (de),a
	pop hl
	ex de,hl
	or a
	sbc hl,de	
	ret
;;--------------------------------
	
.calc_digit
	;; get the digit
	call get_digit	
.calc_digit_jp
	jp calc_digit_0_noinc
;;--------------------------------
	
.get_digit
	ld a,$ff
.get_digit2
	inc a
	or a
	sbc hl,bc
	jp p,get_digit2
	or a
	adc hl,bc
	ret	
	
;;--------------------------------
.write_digit	
	ld (de),a
	inc de
	ret
	
;;--------------------------------
.calc_digit_0_noinc
	or a
	ret z
.calc_digit_notzero	
	;; ok normal
	ld bc,calc_digit_norm
	ld (calc_digit_jp+1),bc

.calc_digit_norm	
	;; write digit into string
	add a,$30
	jr write_digit
	
;;--------------------------------
	
.calc_digit_0_space
	or a
	jr nz,calc_digit_notzero
	ld a,' '
	jr write_digit

;;--------------------------------
