XLIB cpc_EnableDTMessages

defc cas_noisy = $bc6b
defc kl_find_command = $bcd4
defc txt_output = $bb5a

;; use txt vdu enable??

.cpc_EnableDTMessages
ld a,h
or l
ld a,$ff
jr z,disabled_msgs
ld a,$00
.disabled_msgs
push af
call store_or_restore_txt_output
pop af

push af
call cas_noisy

ld hl,set_message_cmd
call kl_find_command
jr nc,no_disc

ld a,c
ld (set_message_call+2),a
ld (set_message_call+0),hl

;; call set message
pop af

;; rst 3, address 0x018
defb $df
defw set_message_call

ret

.no_disc
pop af
ret

store_or_restore_txt_output:
or a
jp nz,store_txt_output
jp restore_txt_output

store_txt_output:
;; used to disable messages
ld a,(txt_output)
ld (txt_output_store+0),a
ld hl,(txt_output+1)
ld (txt_output_store+1),hl

;; nullify txt output so it doesn't report anything
ld a,$c9
ld (txt_output),a

ret

restore_txt_output:
;; used to enable messages
;; restore txt output vector
ld a,(txt_output_store+0)
ld (txt_output),a
ld hl,(txt_output_store+1)
ld (txt_output+1),hl
ret

.txt_output_store
defs 3

.set_message_call
defs 3

.set_message_cmd
defb $81
