XLIB cpc_RestoreFirmwareInterrupt
LIB cpc_StoredFirmwareInterruptData
XREF StoredFirmwareInterruptVector
XREF StoredFirmwareInterruptAltAF
XREF StoredFirmwareInterruptAltBC

;; 
.cpc_RestoreFirmwareInterrupt
	;; restore interrupt vector
	ld a,(cpc_StoredFirmwareInterruptData+StoredFirmwareInterruptVector+0)
	ld ($0038),a
	ld hl,(cpc_StoredFirmwareInterruptData+StoredFirmwareInterruptVector+1)
	ld ($0039),hl
	
	;; swap to AF'
	ex af,af
	;; load into HL
	ld hl,(cpc_StoredFirmwareInterruptData+StoredFirmwareInterruptAltAF)
	;; PUSH/POP to get into AF'
	push hl
	pop af
	;; swap back to AF
	ex af,af
	;; swap to BC',DE',HL'
	exx
	;; load BC'
	ld bc,(cpc_StoredFirmwareInterruptData+StoredFirmwareInterruptAltBC)
	exx
	ret

