XLIB cpc_StretchRect2Y

;; 
.cpc_StretchRect2Y
	ld hl,2
	add hl,sp
	;; height
	ld b,(hl)
	inc hl
	inc hl
	;; width
	ld c,(hl)
	inc hl
	inc hl
	;; dest
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	;; source
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a	
	
.loop_height
	push bc
	push hl
	call copy_line
	call copy_line
	pop hl
	
	;; go to prev line for source now
	call scr_prev_line
	pop bc
	djnz loop_height
	ret

.copy_line
	push bc
	push de
	push hl
.loop_width
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	dec c
	jr nz,loop_width
	pop hl
	pop de
	;; always go to prev line for dest
	ex de,hl
	call scr_prev_line
	ex de,hl
	pop bc
	ret
		
;; from os rom
.scr_prev_line
	ld a,h
	sub a,8
	ld h,a
	ld a,h
	and $38
	cp $38
	ret nz
	ld a,h
	add a,$40
	ld h,a
	ld a,l
	sub $50
	ld l,a
	ret nc
	ld a,h
	dec h
	and $7
	ret nz
	ld a,h
	add a,$8
	ld h,a
	ret
	
