#include "cpcrslib.h"
#include "datos.h"
#include "stdlib.h"

int pointer=0;
char pointerc=0;
void establecer_colores(void) {
	unsigned char i;
	for (i=15;i>0;i--)
		cpc_SetColour(i,paleta[i]);		
}

void draw_bloque(unsigned char x, unsigned char y, unsigned char b){
	cpc_SetTile(2*x,2*y,bloques[b*4]);
	cpc_SetTile(2*x+1,2*y,bloques[b*4+1]);
	cpc_SetTile(2*x,2*y+1,bloques[b*4+2]);
	cpc_SetTile(2*x+1,2*y+1,bloques[b*4+3]);
}


/*void draw_bloqueL(unsigned int z, unsigned char v){
	unsigned char y,t;
    for(y=0;y<10;y++) {
		t=test_map0[256*y+z];	    
		cpc_SetTouchTileXY(0,2*y,bloques[t*4+v]);
		cpc_SetTouchTileXY(0,2*y+1,bloques[t*4+2+v]);
	}
}

void draw_bloqueR (unsigned int z, unsigned char v){
	unsigned char y,t;
    for(y=0;y<10;y++) {
		t=test_map0[256*y+z];
		cpc_SetTouchTileXY(29,2*y,bloques[t*4+v]);
		cpc_SetTouchTileXY(29,2*y+1,bloques[t*4+2+v]);
	}
}
*/
void draw_tilemap(void) {
	unsigned char x,y;
	int t;
    for(y=0;y<10;y++) {
		for(x=0; x<17;x++) {
			t=test_map0[256*y+x];
	      	draw_bloque(x,y,t);	
		}	
	}
}



void drawColumn(void){
	unsigned char i;
	unsigned int z,tt,yy;
	unsigned char y,t;
	z=(pointer+32)>>1;		//situa en columna a leer	    
    i=(char)pointer&1;	
	pointer++;
	//draw_bloqueR(z,i);	
	for(y=0;y<10;y++) {	// recorre el alto de la pantalla
		t=test_map0[256*y+z];  //busca tile
		tt=(t<<2)+i;
		yy=y<<1;
		cpc_SetTouchTileXY(31,yy,bloques[tt]);	// actualiza los tiles de la columna dcha correspondiente
		cpc_SetTouchTileXY(31,yy+1,bloques[tt+2]);
	}
	
 
	
}

	

void drawColumnI(void){
	unsigned char i;
	unsigned int z,tt,yy;
	unsigned char y,t;
	pointer--;
	z=pointer>>1;		//situa en columna a leer	
	i=(char)pointer&1;
//	draw_bloqueL(z,i);	

    for(y=0;y<10;y++) {
		t=test_map0[256*y+z];	    
		tt=(t<<2)+i;
		yy=y<<1;
		cpc_SetTouchTileXY(0,yy,bloques[tt]);
		cpc_SetTouchTileXY(0,yy+1,bloques[tt+2]);
	}
}

void pause(void) {
	#asm
	ld b,30
	.pause_loop
	halt
	djnz pause_loop
	#endasm
}
void collide(void) {
	cpc_SetColour(16,1);
	pause();
	cpc_SetColour(16,9);
}


main(){
	unsigned char cad1[10];
	unsigned char desaparece;
	struct sprite {		// minimun sprite structure
	   	int sp0;		//2 bytes 	01
	   	int sp1;		//2 bytes	23
	   	int coord0;		//2 bytes	45	current superbuffer address
	   	int coord1;		//2 bytes	67  old superbuffer address		
	   	unsigned char cx, cy;	//2 bytes 89 	current coordinates 
	   	unsigned char ox, oy;	//2 bytes 1011  old coordinates 
	   	unsigned char visible;	
	   	unsigned char move;		// 	in this example, to know the movement direction of the sprite
	   	signed int vx;	// coordenadas virtuales
	   							
	   	
   	};
   	
   	
   	struct sprite sprite00, sprite02, sprite01;	
	signed char k;
    unsigned char sc,i,j,z;
    
    cpc_DisableFirmware();
    
    pointer=0;
    sprite00.sp1=sprite2;
	sprite00.sp0=sprite2;
	sprite00.ox=20;
	sprite00.oy=70; 	
	sprite00.cx=20;
	sprite00.cy=70; 	
	sprite00.visible=3;
	cpc_SuperbufferAddress(sprite00); //first time it's important to do this

	
	sprite02.sp1=sprite1;
	sprite02.sp0=sprite1;
	sprite02.ox=40;
	sprite02.oy=70; 	
	sprite02.cx=40;
	sprite02.vx=40;
	sprite02.cy=70; 	
	sprite02.move=0;
	sprite02.visible=0;			//1 = dibujarlo
	
		
    sprite01.sp1=sprite1;
	sprite01.sp0=sprite1;
	sprite01.ox=70;
	sprite01.oy=70; 	
	sprite01.cx=70;
	sprite01.cy=70; 	
	sprite01.move=3;
	sprite01.visible=0;			//1 = dibujarlo
	

		
  	establecer_colores();
   	cpc_SetMode(0);
   	cpc_ClrScr();
    draw_tilemap();
	cpc_ShowTileMap(0);		//rellena el buffer con el mapa y lo enva a pantalla
	cpc_ShowTileMap2();
	desaparece=0;
	while(1){
		
		sc=0;	// No se produce scroll a no ser que se diga lo contrario
/*			
		k=pointer;
		itoa(k,cad1,10);
		cpc_PrintGphStrXY(cad1,29,27);								
	itoa((k+30),cad1,10);
		cpc_PrintGphStrXY(cad1,35,27);				
		
		if (sprite02.visible==1) {
			k=sprite02.vx>>1;
			itoa(k,cad1,10);
			cpc_PrintGphStrXY(cad1,53,27);	
		} else {
			k=sprite02.vx>>1;
			itoa(k,cad1,10);
			cpc_PrintGphStrXY(cad1,53,35);	
		}
			cpc_PrintGphStrXY("XXX",63,35);	
			k=sprite02.ox;
			itoa(k,cad1,10);
			cpc_PrintGphStrXY(cad1,63,35);		 */
				
// MOVIMIENTO DE LOS SPRITES		

// MOVIMIENTO CON TECLADO. CONTROL SCROLL HORIZONTAL	
		if (cpc_TestKey(0)==1 && sprite00.cx<56) {
			if (sprite00.cx==52 && pointer<130)	// Left scroll condition
				sc=1;				// SCROLL IZQUIERDA (<-)
			cpc_SpUpdX(sprite00,2); // En cualquier caso, el sprite se mueve a la derecha
		}
		if (cpc_TestKey(1)==1 && sprite00.cx>0) {
			if (sprite00.cx==4 && pointer>0) // Right scroll condition	
				sc=2;				// SCROLL DERECHA   (->)
			cpc_SpUpdX(sprite00,-2);	// tile by tile move
		}
		if (cpc_TestKey(2)==1 && sprite00.cy>0) cpc_SpUpdY(sprite00,-2);		//Arriba	
		if (cpc_TestKey(3)==1 && sprite00.cy<112) cpc_SpUpdY(sprite00,2);		//Abajo
		
// SPRITES CONTROLADOS POR EL ORDENADOR			

// SPRITE CON MOVIMIENTO VERTICAL		
		// Sprite 1 (UP/DOWN)
		if (sprite01.move==2) { //2 = up, 3 = down								
			if (sprite01.cy>2) cpc_SpUpdY(sprite01,-2);
				else sprite01.move=3;
		}
		if (sprite01.move==3) {  //2 = up, 3 = down								
			if (sprite01.cy<110) cpc_SpUpdY(sprite01,2);
				else sprite01.move=2;
		}	

			
// SPRITE CON MOVIMIENTO HORIZONTAL
		// Sprite 2 (LEFT/RIGHT)	
		if (sprite02.move==0) { 
			if (sprite02.vx>0) {	//dentro de sus coordenadas, se mueve. Sl sprite se mueve ms all de lo visible
					cpc_SpUpdX(sprite02,-1);
					sprite02.vx=sprite02.vx-1;	// Usa coordenada x virtual (vx)
			} else sprite02.move=1;
		}
		if (sprite02.move==1) {  								
			if (sprite02.vx<80) {
				cpc_SpUpdX(sprite02,1);
				sprite02.vx=sprite02.vx+1;
			} else sprite02.move=0;
		}	
		// El sprite se ve solo si sus coordenadas virtuales estn dentro de los rangos de la pantalla virtual
		// k>=vx>=k+64
		k=sprite02.vx>>1;
		if (k>=pointer && k<=(pointer+30)) { // se deja de dibujar al salir de la pantalla!!
			sprite02.visible=1;
		} else {
			if (sprite02.visible==1) desaparece=1;		// el sprite acaba de desaparecer
			sprite02.visible=0;
		}		

// ACTUALIZACIN DE LA PANTALLA:		

		switch (sc) {
					
		case 0:	// No se ha producido scroll, se actualizan los sprites en la pantalla
		// Ciclo dibujado sprites en mapa de tiles/pantalla:
			cpc_ResetTouchedTiles();		//clear touched tile table	
			cpc_PutSpTileMap(sprite00);
			if (desaparece==1) {			// cuando un sprite sale de la pantalla, se borra del mapa de tiles
				desaparece=0;				// 
				cpc_PutSpTileMapO(sprite02);
			}
			if (sprite01.visible==1) cpc_PutSpTileMap(sprite01);	
			if (sprite02.visible==1) cpc_PutSpTileMap(sprite02);		// No tengo claro porqu, pero as va bien.
					
			cpc_UpdScr();					// Restaura los tiles tocados por los sprites
			
			cpc_PutTrSpTileMap2b(sprite00);
			
		    if (sprite01.visible==1) cpc_PutTrSpTileMap2b(sprite01);
			if (sprite02.visible==1) cpc_PutTrSpTileMap2b(sprite02);	
			if (sprite02.ox>127) sprite02.ox=0;	// Para evitar cuelgues si la coordenada se hace negativa
			cpc_ShowTouchedTiles2();	// solo muestra los tiles de los sprites
			break;			
			
		
		case 1:											// si ha habido scroll hacia la izquierda
			cpc_ResetTouchedTiles();	
			cpc_PutSpTileMap(sprite00);		// Para actualizar los tiles q toca el sprite
			cpc_UpdScr();							// restaura los tiles actualizados
			cpc_PutTrSpTileMap2b(sprite00);	// Ahora se dibuja el sprite
			sprite00.ox -=2;
			sprite00.cx -=2;
			cpc_ResetTouchedTiles();			
			cpc_ScrollLeft0();						// scroll area tiles
			drawColumn();							// actualiza area tiles nueva columna				
			cpc_UpdScr();							// restaura los tiles actualizados
			k=sprite02.vx>>1;
			if (k>=pointer && k<=(pointer+30)) { // se deja de dibujar al salir de la pantalla!!
				sprite02.visible=1;
			} else {
				sprite02.visible=0;
			}
			sprite01.cx -=2;
			sprite02.cx -=2;
			sprite01.ox -=2;
			sprite02.ox -=2;
			k=sprite01.cx;
			if (k>0 && k<60) {
				sprite01.visible=1;
			} else {
				if (sprite02.visible==1) desaparece=1;		// el sprite acaba de desaparecer
				sprite01.visible=0;
			}	
			cpc_ResetTouchedTiles();	
			cpc_PutSpTileMap(sprite00);		// Para actualizar los tiles q toca el sprite
			if (desaparece==1) {
				desaparece=0;
				cpc_PutSpTileMapO(sprite02);
			}			
			if (sprite01.visible==1) cpc_PutSpTileMap(sprite01);
			if (sprite02.visible==1) cpc_PutSpTileMap(sprite02);		
			cpc_UpdScr();							// restaura los tiles actualizados
			cpc_PutTrSpTileMap2b(sprite00);	// Ahora se dibuja el sprite
			if (sprite01.visible==1) cpc_PutTrSpTileMap2b(sprite01);
			if (sprite02.visible==1) cpc_PutTrSpTileMap2b(sprite02);
			
			cpc_ShowTileMap2();
				if (sprite02.ox>127) sprite02.ox=0;
			break;

		case 2:											// si ha habido scroll hacia la derecha
			cpc_ResetTouchedTiles();	
			cpc_PutSpTileMap(sprite00);		// Para actualizar los tiles q toca el sprite
			cpc_UpdScr();							// restaura los tiles actualizados
			cpc_PutTrSpTileMap2b(sprite00);	// Ahora se dibuja el sprite

			sprite00.ox +=2;
			sprite00.cx +=2;

									
			cpc_ResetTouchedTiles();			
			cpc_ScrollRight0();
			drawColumnI();			
			cpc_UpdScr();				// restaura los tiles actualizados

			k=sprite02.vx>>1;
			if (k>=pointer && k<=(pointer+30)) { // se deja de dibujar al salir de la pantalla!!
				sprite02.visible=1;
			} else {
				if (sprite02.visible==1) desaparece=1;		// el sprite acaba de desaparecer
				sprite02.visible=0;
			}
								
			sprite01.cx +=2;
			sprite02.cx +=2;
			sprite01.ox +=2;
			sprite02.ox +=2;	

			k=sprite01.cx;
			if (k>0 && k<60) {
				sprite01.visible=1;
			} else {
				sprite01.visible=0;
			}	
			cpc_ResetTouchedTiles();	
			cpc_PutSpTileMap(sprite00);		// Para actualizar los tiles q toca el sprite
			if (sprite01.visible==1) cpc_PutSpTileMap(sprite01);
			if (sprite02.visible==1) cpc_PutSpTileMap(sprite02);		
			
		
			cpc_UpdScr();					// restaura los tiles actualizados
			cpc_PutTrSpTileMap2b(sprite00);	// Ahora se dibuja el sprite
			if (desaparece==1) {	
				desaparece=0;
				cpc_PutSpTileMapO(sprite02);
			}			
			if (sprite01.visible==1) cpc_PutTrSpTileMap2b(sprite01);
			if (sprite02.visible==1) cpc_PutTrSpTileMap2b(sprite02);
			if (sprite02.ox>127) sprite02.ox=0;
			cpc_ShowTileMap2();	
			break;
			
		}				
		
		
		
	}
}
