XLIB cpc_CopySpriteRectangleToScreen
LIB cpc_NextScrLine

.cpc_CopySpriteRectangleToScreen
	ld ix,2
	add ix,sp
	
	;; Src
	ld l,(ix+6)
	ld h,(ix+7)

	;; SrcWidth
	ld e,(ix+0)
	ld d,0
	ld (loop_add+1),de
	
	;; Src Y
	ld b,(ix+2)
	
	;; Y = 0?
	inc b
	dec b
	jr z,nosrcmul
	
	
	;; SrcY*SrcWidth
.srcmulloop
	add hl,de
	djnz srcmulloop
.nosrcmul
	;; Src X
	ld e,(ix+4)
	ld d,0
	add hl,de
	
	;; hl = dest
	ld e,(ix+12)
	ld d,(ix+13)

	;; Dest Width
	ld b,(ix+10)
	
	;; Dest Height
	ld c,(ix+8)
	
.loop_height
	push bc
	push hl
	push de
	
	;; copy bytes
.loop_width
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	
	dec c
	jr nz,loop_width

	pop hl
	call cpc_NextScrLine
	ex de,hl	
	
	pop hl
	;; HL = address in sprite
	;; add on sprite width to get next line down
.loop_add
	ld bc,0
	add hl,bc
	
.loop_height2
	pop bc
	djnz loop_height
	ret

