XLIB cpc_DrawColouredBar0
LIB cpc_NextScrLine

.cpc_DrawColouredBar0
	ld ix,2
	add ix,sp
	
	
	;; 0 = colour
	;; 2 = height
	;; 4 = width
	;; 6 = addr
		
	ld c,(ix+4)
	ld b,(ix+5)
	;; if zero length then do not plot anything
	ld a,b
	or c
	ret z
	
	ld e,c
	
	;; divide by 2
	srl b
	rr c
	;; C = width in bytes
		
	;; address to write to
	ld l,(ix+6)
	ld h,(ix+7)
	
	;; height in lines
	ld b,(ix+2)
	ld a,(ix+0)

.fill_lines
	push af
	push bc
	push hl
	;; if zero bytes do not plot anything	
	inc c
	dec c
	jr z,fill_pixel
.fill_bytes
	ld (hl),a
	inc hl
	dec c
	jr nz,fill_bytes
.fill_pixel	
	;; an odd pixel on end?
	bit 0,e
	jr z,no_pixel
	;; isolate pixel
	and $aa
	ld (hl),a
	inc hl
	xor a
	ld (hl),a
.no_pixel
	pop hl
	call cpc_NextScrLine
	pop bc
	pop af
	djnz fill_lines
	ret



