XLIB cpc_LoadBinary

defc cas_in_open = $bc77
defc cas_in_direct = $bc83
defc cas_in_close = $bc7a
defc cas_in_abandon = $bc7d

;; 
.cpc_LoadBinary
	ld ix,2
	add ix,sp

	;; hl = addr
	ld l,(ix+0)
	ld h,(ix+1)
	push hl
	
	ld l,(ix+2)
	ld h,(ix+3)
	push hl
	ld b,$ff
.loop1
	inc b
	ld a,(hl)
	inc hl
	or a
	jr nz,loop1
	pop hl
	ld de,$c000
	call cas_in_open
	jr nc,error
	pop hl
	call cas_in_direct
	jr nc,error2
	call cas_in_close
	jr nc,error2
	ld hl,0
	ret
.error	
	;; pop load address
	pop hl
.error2
	;; fail
	push af
	call cas_in_abandon
	pop af
	ld l,a
	ld h,0
	ret
	
	;; a = 0x90
	
