; ******************************************************
; **       Librera de rutinas para Amstrad CPC       **
; **	   Ral Simarro, 	  Artaburu 2007       **
; ******************************************************

XLIB cpc_PrintGphStr20
XREF colores_camb
LIB cpc_CharColours
LIB cpc_Chars
XREF first_char
LIB cpc_PutChar

.cpc_PrintGphStr20 

;HL destino
;DE origen

ld (direcc_destino),hl
ex de,hl

.bucle_texto0
;;ld a,1
;;ld (imprimiendo),a

ld a,(first_char)
ld b,a		;resto 48 para saber el nmero del caracter (En ASCII 0=48)

ld a,(hl)		;; end of string?
or a 
ret z
sub b
ld bc,cpc_Chars	;apunto a la primera letra
push hl		;; string address


ld l,a		;en A tengo la letra que sera
ld h,0
add hl,hl
add hl,hl
add hl,hl	;x8 porque cada letra son 8 bytes
add hl,bc	;ahora HL apunta a los datos de la letra correspondiente

call escribe_letra
ld hl,(direcc_destino)

ld de,letra_decodificada
;ld A,8	;alto  
call cpc_PutChar
ld hl,(direcc_destino)
inc hl
inc hl
ld (direcc_destino),hl

pop hl
inc hl
jr bucle_texto0

;;.imprimiendo defb 0
.direcc_destino defw 0
		

.escribe_letra
push de
ld iy,letra_decodificada
ld b,8
.bucle_alto
push bc
push hl

ld e,(hl)
call op_colores	
ld (iy+0),d
inc iy
call op_colores
ld (iy+0),d
inc iy

pop hl
inc hl
pop bc
djnz bucle_alto
pop de
ret

.op_colores
ld d,0			;; initial byte at end will be result of 2 pixels combined

call op_colores_pixel	;; do pixel 0 
rlc d
call op_colores_pixel
rrc d
ret

;; follow through to do pixel 1

.op_colores_pixel
;; shift out pixel into bits 0 and 1 (source)
rlc e
rlc e

;; isolate
ld a,e
and $3
ld hl,cpc_CharColours+colores_camb
add a,l
ld l,a
ld a,h
adc a,0
ld h,a
;; read it and combine with pixel so far
ld a,d
or (hl)
ld d,a
ret


.letra_decodificada defs 16	;uso este espacio para guardar la letra que se decodifica
