XLIB cpc_SaveBinary

defc cas_out_open = $bc8c
defc cas_out_direct = $bc98
defc cas_out_close = $bc8f
defc cas_out_abandon = $bc92
defc cas_noisy = $bc6b

;; 
.cpc_SaveBinary
	ld ix,2
	add ix,sp
	
	
	;; bc = length
	ld c,(ix+0)
	ld b,(ix+1)
	push bc
	
	;; hl = addr
	ld l,(ix+2)
	ld h,(ix+3)
	push hl
	
	;; filename
	ld l,(ix+4)
	ld h,(ix+5)
	push hl
	
	ld b,$ff
.loop1
	inc b
	ld a,(hl)
	inc hl
	or a
	jr nz,loop1
	pop hl
	ld de,$c000
	call cas_out_open
	jr nc,error
	pop hl
	pop de
	ld bc,0
	ld a,2
	call cas_out_direct
	jr nc,error2
	call cas_out_close
	jr nc,error2

	;; ok
	ld hl,0	
	ret
.error	
	;; pop load address
	pop hl
	;; pop length
	pop bc
.error2
	push af
	call cas_out_abandon
	pop af
	ld l,a
	ld h,0
	ret
	

