set PATH=%PATH%;c:\tools
SET Z88DK=C:\z88dk\
SET Z80_OZFILES=%Z88DK%\LIB\
SET ZCCCFG=%Z88DK%\LIB\CONFIG\
SET PATH=%PATH%;%Z88DK%\BIN
cd gfx
call convert.bat
cd ..
cd lib\cpcrslib
call make.bat
copy cpcrslib.lib c:\z88dk\lib\clibs
copy cpcrslib.h c:\z88dk\include
cd ..\..
cd lib\morelib
call make.bat
copy morelib.lib c:\z88dk\lib\clibs
copy morelib.h c:\z88dk\include
cd ..\..
cd lib\starkos
call make.bat
cd ..\..

cd music
call make.bat
cd ..

REM copy cpc_cas_crt0.asm c:\z88dk\lib
REM copy cpc_cas.cfg c:\z88dk\lib\config
REM copy cpc_cas.lnx c:\z88dk\lib\config


copy cpc_disc_crt0.asm cpc_disc_crt0.opt
REM copy z80rules.0 c:\z88dk\lib
copy cpc_disc_crt0.asm c:\z88dk\lib
copy cpc_disc_crt0.opt c:\z88dk\lib
copy cpc_disc.cfg c:\z88dk\lib\config
copy cpc_disc.lnx c:\z88dk\lib\config
REM 42616


zcc -a -O3 -Wall -DDISC=1 -unsigned font.asm tiles.asm bkbuff.asm logo.asm largescoregfx.asm WinLoseGfx.asm StopGoGfx.asm lib\starkos\starkos.asm lib\starkos\relsong.asm mainmusic.asm movesfx.asm selectsfx.asm lostmusic.asm winmusic.asm gamemusic.asm cpcgame.c 
if %ERRORLEVEL% NEQ 0 goto :error
zcc +cpc_disc -zorg=512 -create-app -O3 -Wall -unsigned -lcpcrslib -lmorelib -DDISC=1 -o bin\game lib\starkos\starkos.asm lib\starkos\relsong.asm font.asm mainmusic.asm movesfx.asm selectsfx.asm lostmusic.asm winmusic.asm gamemusic.asm tiles.asm bkbuff.asm logo.asm largescoregfx.asm WinLoseGfx.asm StopGoGfx.asm cpcgame.c -m
if %ERRORLEVEL% NEQ 0 goto :error
REM only to check asm files!
REM zorg only works if you use zcc to build and link
del temp\game_x.asm
del temp\game_l.asm
del temp\game_s.asm

fileattr -x bin\game.cpc >temp\game_x.asm
fileattr -l bin\game.cpc >temp\game_l.asm
fileattr -s bin\game.cpc >temp\game_s.asm

REM testing]
REM pasmo --amsdos discload.asm bin\discload.bin
REM if %ERRORLEVEL% NEQ 0 goto :error
REM pasmo --amsdos discload_short.asm bin\discload_short.bin
REM if %ERRORLEVEL% NEQ 0 goto :error
REM pasmo --amsdos discload_alt.asm bin\discload_alt.bin
REM if %ERRORLEVEL% NEQ 0 goto :error
pasmo --amsdos discload_alt_new.asm bin\discload_alt_new.bin
if %ERRORLEVEL% NEQ 0 goto :error
REM disc version
addhead -r gfx\bin\loadscr.bin gfx\bin\loadscr.bin
addhead -a -t "binary" -s 49152 gfx\bin\loadscr.bin gfx\bin\loadscr.bin

addhead -r gfx\bin\gui.bin gfx\bin\gui.bin
addhead -a -t "binary" -s 49152 gfx\bin\gui.bin gfx\bin\gui.bin

copy cpcgame.opt cpcgame_disc.opt
copy bin\game.cpc bin\game_dsk.cpc
copy bin\game.map bin\game_dsk.map 

addhead -c 0xa200 -s 512 bin\game_dsk.cpc
if %ERRORLEVEL% NEQ 0 goto :error

cpcxfsw -f -nD bin\dsk\bangel69_A.dsk

dsktool "bin\dsk\bangel69_A.dsk" -o 1 -t 0 -s 0 -i 0x0c1 "ba_cat_art.bin"
REM cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\loadscr.bin bangel69.bi1
REM cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p bin\game.cpc bangel69.bi2
REM cpcxfsw bin\dsk\bangel69_A.dsk -f -p gfx\bin\gui.bin bangel69.bi3
REM cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p bin\discload_alt.bin bangel69.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p bin\discload_alt_new.bin bangel69.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p bin\game.cpc bangel69.bi1
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\gui.bin bangel69.bi2
REM testing
REM cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p bin\discload_short.bin b69.bin
REM cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p bin\discload_alt.bin b69a.bin
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bin
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bi1
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bi2
REM cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bi3

addhead -r gfx\bin\l01.bin gfx\bin\l01.bin
addhead -a -t "binary" -s 49152 gfx\bin\l01.bin gfx\bin\l01.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l01.bin bangel69.bk0
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk0

addhead -r gfx\bin\l02.bin gfx\bin\l02.bin
addhead -a -t "binary" -s 49152 gfx\bin\l02.bin gfx\bin\l02.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l02.bin bangel69.bk1
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk1

addhead -r gfx\bin\l03.bin gfx\bin\l03.bin
addhead -a -t "binary" -s 49152 gfx\bin\l03.bin gfx\bin\l03.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l03.bin bangel69.bk2
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk2

addhead -r gfx\bin\l04.bin gfx\bin\l04.bin
addhead -a -t "binary" -s 49152 gfx\bin\l04.bin gfx\bin\l04.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l04.bin bangel69.bk3
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk3

addhead -r gfx\bin\l05.bin gfx\bin\l05.bin
addhead -a -t "binary" -s 49152 gfx\bin\l05.bin gfx\bin\l05.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l05.bin bangel69.bk4
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk4

addhead -r gfx\bin\l06.bin gfx\bin\l06.bin
addhead -a -t "binary" -s 49152 gfx\bin\l06.bin gfx\bin\l06.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l06.bin bangel69.bk5
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk5 

addhead -r gfx\bin\l07.bin gfx\bin\l07.bin
addhead -a -t "binary" -s 49152 gfx\bin\l07.bin gfx\bin\l07.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l07.bin bangel69.bk6
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk6 

addhead -r gfx\bin\l08.bin gfx\bin\l08.bin
addhead -a -t "binary" -s 49152 gfx\bin\l08.bin gfx\bin\l08.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l08.bin bangel69.bk7
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk7 

addhead -r gfx\bin\l09.bin gfx\bin\l09.bin
addhead -a -t "binary" -s 49152 gfx\bin\l09.bin gfx\bin\l09.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l09.bin bangel69.bk8
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk8

addhead -r gfx\bin\l10.bin gfx\bin\l10.bin
addhead -a -t "binary" -s 49152 gfx\bin\l10.bin gfx\bin\l10.bin
cpcxfsw bin\dsk\bangel69_A.dsk -f -b -p gfx\bin\l10.bin bangel69.bk9
cpcxfsw bin\dsk\bangel69_A.dsk -e ATTRIB -R/O -SYS bangel69.bk9


cpcxfsw -f -nD bin\dsk\bangel69_B.dsk

dsktool "bin\dsk\bangel69_B.dsk" -o 1 -t 0 -s 0 -i 0x0c1 "ba_cat_art.bin"
REM cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\loadscr.bin bangel69.bi1
REM cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p bin\game.cpc bangel69.bi2
REM cpcxfsw bin\dsk\bangel69_B.dsk -f -p gfx\bin\gui.bin bangel69.bi3
REM cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p bin\discload_alt.bin bangel69.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p bin\discload_alt_new.bin bangel69.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p bin\game.cpc bangel69.bi1
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\gui.bin bangel69.bi2
REM testing
REM cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p bin\discload_short.bin b69.bin
REM cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p bin\discload_alt.bin b69a.bin
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bin
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bi1
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bi2
REM cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bi3

addhead -r gfx\bin\lb01.bin gfx\bin\lb01.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb01.bin gfx\bin\lb01.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb01.bin bangel69.bk0
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk0

addhead -r gfx\bin\lb02.bin gfx\bin\lb02.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb02.bin gfx\bin\lb02.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb02.bin bangel69.bk1
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk1

addhead -r gfx\bin\lb03.bin gfx\bin\lb03.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb03.bin gfx\bin\lb03.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb03.bin bangel69.bk2
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk2

addhead -r gfx\bin\lb04.bin gfx\bin\lb04.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb04.bin gfx\bin\lb04.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb04.bin bangel69.bk3
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk3

addhead -r gfx\bin\lb05.bin gfx\bin\lb05.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb05.bin gfx\bin\lb05.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb05.bin bangel69.bk4
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk4

addhead -r gfx\bin\lb06.bin gfx\bin\lb06.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb06.bin gfx\bin\lb06.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb06.bin bangel69.bk5
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk5 

addhead -r gfx\bin\lb07.bin gfx\bin\lb07.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb07.bin gfx\bin\lb07.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb07.bin bangel69.bk6
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk6 

addhead -r gfx\bin\lb08.bin gfx\bin\lb08.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb08.bin gfx\bin\lb08.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb08.bin bangel69.bk7
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk7 

addhead -r gfx\bin\lb09.bin gfx\bin\lb09.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb09.bin gfx\bin\lb09.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb09.bin bangel69.bk8
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk8

addhead -r gfx\bin\lb10.bin gfx\bin\lb10.bin
addhead -a -t "binary" -s 49152 gfx\bin\lb10.bin gfx\bin\lb10.bin
cpcxfsw bin\dsk\bangel69_B.dsk -f -b -p gfx\bin\lb10.bin bangel69.bk9
cpcxfsw bin\dsk\bangel69_B.dsk -e ATTRIB -R/O -SYS bangel69.bk9



copy cpc_cas_crt0.asm cpc_cas_crt0.opt

copy cpc_cas_crt0.asm c:\z88dk\lib
copy cpc_cas_crt0.opt c:\z88dk\lib
copy cpc_cas.cfg c:\z88dk\lib\config
copy cpc_cas.lnx c:\z88dk\lib\config

zcc -a -O3 -Wall -DCASSETTE=1 -unsigned font.asm lib\starkos\starkos.asm lib\starkos\relsong.asm tiles.asm bkbuff.asm levels.asm movesfx.asm selectsfx.asm mainmusic.asm cpcgame.c 
if %ERRORLEVEL% NEQ 0 goto :error


REM make tape
zcc +cpc_cas -zorg=512 -create-app -O3 -Wall -unsigned -lcpcrslib -lmorelib -DCASSETTE=1 -o bin\game lib\starkos\starkos.asm lib\starkos\relsong.asm font.asm mainmusic.asm tiles.asm bkbuff.asm levels.asm movesfx.asm selectsfx.asm cpcgame.c -m
if %ERRORLEVEL% NEQ 0 goto :error

del temp\game_x.asm
del temp\game_l.asm
del temp\game_s.asm

REM only to check asm files!
REM zorg only works if you use zcc to build and link
fileattr -x bin\game.cpc >temp\game_x.asm
fileattr -l bin\game.cpc >temp\game_l.asm
fileattr -s bin\game.cpc >temp\game_s.asm

copy bin\game.cpc bin\game_casA.cpc 
copy bin\game.map bin\game_casA.map 
copy cpcgame.opt cpcgame_casA.opt

addhead -c 0xc000 -s 512 bin\game_casA.cpc
if %ERRORLEVEL% NEQ 0 goto :error

REM zmac.exe -l -o bin\tapeload.bin tapeload.asm
REM addhead -r bin\tapeload.bin bin\tapeload.bin
REM addhead -a -s 256 -x 256 bin\tapeload.bin bin\tapeload.bin

REM build for side A
pasmo --amsdos tapeload_alt.asm bin\tapeload_alt.bin
if %ERRORLEVEL% NEQ 0 goto :error


addhead -r gfx\bin\loadscr.bin gfx\bin\loadscr.bin
addhead -r gfx\bin\gui.bin gfx\bin\gui.bin
addhead -r bin\game.cpc bin\game.cpc

REM 2cdt -n bin\tapeload.bin -r BANGEL69 bin\cdt\bangel69_A.cdt 
2cdt -n bin\tapeload_alt.bin -r "BLUE ANGEL 69" bin\cdt\bangel69_A.cdt 
2cdt -m 2 gfx\bin\loadscr.bin bin\cdt\bangel69_A.cdt 
2cdt -m 2 bin\game.cpc bin\cdt\bangel69_A.cdt 
2cdt -m 2 gfx\bin\gui.bin bin\cdt\bangel69_A.cdt

setlocal EnableDelayedExpansion

echo. ; ** COLOURS >temp\snapcolcfg.txt
set /a col=0
FOR /F "eol=;tokens=1" %%i in (gfx\bin\gamepal.txt) do (
	@echo -s GA_PAL:!col! 0x%%i >>temp\snapcolcfg.txt
	set /a col+=1
%%i"
)
echo ; ** END COLOURS >>temp\snapcolcfg.txt
endlocal

copy snapheadcfg.txt+temp\snapcolcfg.txt snapshot.cfg


copy bin\game.cpc bin\snapgame.cpc
copy gfx\bin\gui.bin gfx\bin\snapgui.bin
addhead -r gfx\bin\snapgui.bin gfx\bin\snapgui.bin

createSnapshot -c snapshot.cfg bin\tapeA.sna

zcc -a -O3 -Wall -DCASSETTE=1 -unsigned font.asm tiles.asm bkbuff.asm levels_B.asm movesfx.asm selectsfx.asm cpcgame.c 
if %ERRORLEVEL% NEQ 0 goto :error

REM make tape
zcc +cpc_cas -zorg=512 -create-app -O3 -Wall -unsigned -lcpcrslib -lmorelib -DCASSETTE=1 -o bin\game lib\starkos\starkos.asm lib\starkos\relsong.asm font.asm mainmusic.asm tiles.asm bkbuff.asm levels_B.asm movesfx.asm selectsfx.asm cpcgame.c -m
if %ERRORLEVEL% NEQ 0 goto :error


del temp\game_x.asm
del temp\game_l.asm
del temp\game_s.asm

REM only to check asm files!
REM zorg only works if you use zcc to build and link
fileattr -x bin\game.cpc >temp\game_x.asm
fileattr -l bin\game.cpc >temp\game_l.asm
fileattr -s bin\game.cpc >temp\game_s.asm

copy bin\game.cpc bin\game_casB.cpc 
copy bin\game.map bin\game_casB.map 
copy cpcgame.opt cpcgame_casB.opt

addhead -c 0xc000 -s 512 bin\game_casB.cpc
if %ERRORLEVEL% NEQ 0 goto :error

REM zmac.exe -l -o bin\tapeload.bin tapeload.asm
REM addhead -r bin\tapeload.bin bin\tapeload.bin
REM addhead -a -s 256 -x 256 bin\tapeload.bin bin\tapeload.bin

REM build for side B
pasmo --amsdos tapeload_alt.asm bin\tapeload_alt.bin
if %ERRORLEVEL% NEQ 0 goto :error

addhead -r gfx\bin\loadscr.bin gfx\bin\loadscr.bin
addhead -r gfx\bin\gui.bin gfx\bin\gui.bin
addhead -r bin\game.cpc bin\game.cpc

2cdt -n bin\tapeload_alt.bin -r "BLUE ANGEL 69" bin\cdt\bangel69_B.cdt 
2cdt -m 2 gfx\bin\loadscr.bin bin\cdt\bangel69_B.cdt 
2cdt -m 2 bin\game.cpc bin\cdt\bangel69_B.cdt 
2cdt -m 2 gfx\bin\gui.bin bin\cdt\bangel69_B.cdt

copy bin\game.cpc bin\snapgame.cpc
addhead -r bin\snapgame.cpc bin\snapgame.cpc
createSnapshot -c snapshot.cfg bin\tapeB.sna


7za a -r bangel69.zip bin\cdt bin\dsk bin\doc

goto end

:error

pause


:end
