set PATH=%PATH%;c:\tools
SET Z88DK=C:\z88dk\
SET Z80_OZFILES=%Z88DK%\LIB\
SET ZCCCFG=%Z88DK%\LIB\CONFIG\
SET PATH=%PATH%;%Z88DK%\BIN
cd gfx
call convert.bat
cd ..
cd lib\cpcrslib
call make.bat
copy cpcrslib.lib c:\z88dk\lib\clibs
copy cpcrslib.h c:\z88dk\include
cd ..\..
cd lib\morelib
call make.bat
copy morelib.lib c:\z88dk\lib\clibs
copy morelib.h c:\z88dk\include
cd ..\..
cd lib\starkos
call make.bat
cd ..\..

zcc -a -O3 -Wall -unsigned font.asm tiles.asm cpcgame.c 
if %ERRORLEVEL% NEQ 0 goto :error
zcc +cpc -zorg=8192 -create-app -O3 -Wall -unsigned -lcpcrslib -lmorelib -o bin\game lib\starkos\starkos.asm lib\starkos\relsong.asm font.asm music.asm tiles.asm levels.asm cpcgame.c -m
if %ERRORLEVEL% NEQ 0 goto :error
REM only to check asm files!
REM zorg only works if you use zcc to build and link
fileattr -x bin\game.cpc >temp\game_x.asm
fileattr -l bin\game.cpc >temp\game_l.asm
fileattr -s bin\game.cpc >temp\game_s.asm

REM disc version
zmac.exe -l -o bin\discload.bin discload.asm
addhead -r gfx\bin\loadscr.bin gfx\bin\loadscr.bin
addhead -a -t "binary" -s 49152 gfx\bin\loadscr.bin gfx\bin\loadscr.bin

addhead -r gfx\bin\gui.bin gfx\bin\gui.bin
addhead -a -t "binary" -s 49152 gfx\bin\gui.bin gfx\bin\gui.bin

addhead -r bin\discload.bin bin\discload.bin
addhead -a -s 256 -x 256 bin\discload.bin bin\discload.bin
cpcxfsw -f -nD bin\dsk\bangel69.dsk
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\loadscr.bin bangel69.bi1 -p bin\discload.bin bangel69.bin -p bin\game.cpc bangel69.bi2 -p gfx\bin\gui.bin bangel69.bi3


addhead -r gfx\bin\l01_pu.bin gfx\bin\l01_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l01_pu.bin gfx\bin\l01_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l01_pu.bin bangel69.bk0

addhead -r gfx\bin\l02_pu.bin gfx\bin\l02_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l02_pu.bin gfx\bin\l02_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l02_pu.bin bangel69.bk1

addhead -r gfx\bin\l03_pu.bin gfx\bin\l03_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l03_pu.bin gfx\bin\l01_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l03_pu.bin bangel69.bk2

addhead -r gfx\bin\l04_pu.bin gfx\bin\l04_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l04_pu.bin gfx\bin\l04_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l04_pu.bin bangel69.bk3

addhead -r gfx\bin\l05_pu.bin gfx\bin\l05_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l05_pu.bin gfx\bin\l05_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l05_pu.bin bangel69.bk4

addhead -r gfx\bin\l06_pu.bin gfx\bin\l06_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l06_pu.bin gfx\bin\l06_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l06_pu.bin bangel69.bk5

addhead -r gfx\bin\l07_pu.bin gfx\bin\l07_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l07_pu.bin gfx\bin\l07_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l07_pu.bin bangel69.bk6

addhead -r gfx\bin\l08_pu.bin gfx\bin\l01_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l01_pu.bin gfx\bin\l01_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l08_pu.bin bangel69.bk7

addhead -r gfx\bin\l09_pu.bin gfx\bin\l09_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l09_pu.bin gfx\bin\l09_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l09_pu.bin bangel69.bk8

addhead -r gfx\bin\l10_pu.bin gfx\bin\l10_pu.bin
addhead -a -t "binary" -s 49152 gfx\bin\l10_pu.bin gfx\bin\l10_pu.bin
cpcxfsw bin\dsk\bangel69.dsk -f -b -p gfx\bin\l10_pu.bin bangel69.bk9



REM make tape
zmac.exe -l -o bin\tapeload.bin tapeload.asm
addhead -r bin\tapeload.bin bin\tapeload.bin
addhead -a -s 256 -x 256 bin\tapeload.bin bin\tapeload.bin

2cdt -n bin\tapeload.bin -r BANGEL69 bin\cdt\bangel69.cdt 
2cdt -m 2 gfx\bin\scr.bin bin\cdt\bangel69.cdt 
2cdt -m 2 bin\game.cpc bin\cdt\bangel69.cdt 
2cdt -m 2 gfx\bin\gui.bin bin\cdt\bangel69.cdt

goto end

:error

pause


:end
